__author__ = 'kelvinn'
from sqlalchemy import *
from sqlalchemy.orm import create_session, sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from geoalchemy import postgis
from sqlalchemy.orm import relationship, backref
from geoalchemy import *
import simplejson as json
import urllib2
import os
import csv
import itertools

#Create and engine and get the metadata
#Base = declarative_base()

engine = create_engine('postgresql://abs:abs@localhost/abs', echo=False) #change here if want to view echo
Session = sessionmaker(bind=engine)
session = Session()

metadata = MetaData(bind=engine)
Base = declarative_base(metadata=metadata)


class sa2(Base):
    __tablename__ = 'sa2'
    __table_args__ = {'autoload': True, 'schema': 'asgs_2011'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


class sydney_transit(Base):
    __tablename__ = 'tz_nsw_2011'
    __table_args__ = {'schema': 'govhack_2013'}
    gid = Column(Integer, primary_key=True)
    sa2 = Column(Integer, ForeignKey('asgs_2011.sa2.code'))
    sa2_main11 = Column(Integer)
    sa2_obj = relationship("sa2", backref="tz")
    geom = GeometryColumn(MultiPolygon(1,srid=4326))

#tz_obj = session.query(sydney_transit).filter(sydney_transit.gid == 10).first()
all_tz_list = session.query(sydney_transit)
for tz_obj in all_tz_list:
    sa2_obj = session.query(sa2).filter(sa2.code == str(tz_obj.sa2_main11)).first()
    if sa2_obj and tz_obj:
        #c = sydney_transit()
        tz_obj.sa2 = sa2_obj.code
        session.add(tz_obj)
    else:
        print tz_obj.sa2_main11
session.commit()