__author__ = 'kelvinn'
from sqlalchemy import *
from sqlalchemy.orm import create_session, sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from geoalchemy import postgis
from geoalchemy import *
import simplejson as json
import urllib2
import itertools
import csv

#Create and engine and get the metadata
#Base = declarative_base()

engine = create_engine('postgresql://abs:abs@localhost/abs', echo=False) #change here if want to view echo
Session = sessionmaker(bind=engine)
session = Session()


metadata = MetaData(bind=engine)
Base = declarative_base(metadata=metadata)

class medicare(Base):
    __tablename__ = 'medicare'
    __table_args__ = {'autoload': True, 'schema': 'govhack_2013'}
    geom = GeometryColumn(Point())

class centrelink(Base):
    __tablename__ = 'centrelink'
    __table_args__ = {'autoload': True, 'schema': 'govhack_2013'}
    geom = GeometryColumn(Point())

class sa1(Base):
    __tablename__ = 'sa1'
    __table_args__ = {'autoload': True, 'schema': 'asgs_2011'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))

class sydney_transit(Base):
    __tablename__ = 'tz_nsw_2011'
    __table_args__ = {'autoload': True, 'schema': 'govhack_2013'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))

class universities(Base):
    __tablename__ = 'universities'
    __table_args__ = {'autoload': True, 'schema': 'govhack_2013'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))

box = 'POLYGON((149.343 -34.865, 151.908 -34.865, 151.908 -32.384, 149.343 -32.384, 149.343 -34.865))'
#origin_list = session.query(sydney_transit).filter(sydney_transit.geom.within(box))
#origin_list = session.query(centrelink).filter(centrelink.geom.within(box))
#destination_list = session.query(medicare).filter(medicare.geom.within(box))
origin_list = session.query(universities).all()

def get_coords(item):
    json_coords = session.scalar(postgis.pg_functions.geojson(functions.centroid(item.geom)))
    coords = json.loads(json_coords)['coordinates']
    return coords[1], coords[0]

with open('uni_list.csv', 'wb') as origincsvfile:
    originwriter = csv.writer(origincsvfile, delimiter=',')
    originwriter.writerow(["label","latitude","longitude","input"])
    for origin in origin_list:
        try:
            #lat, lng = get_coords(origin)
            #ll = [origin.gid, lat, lng, "1"] #need to update this bit

            ll = [origin.gid, origin.latitude, origin.longitude, "1"]
            print ll
            originwriter.writerow(ll)
        except:
            "Major error"



