__author__ = 'kelvinn'
from sqlalchemy import *
from sqlalchemy.orm import create_session, sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from geoalchemy import postgis
from sqlalchemy.orm import relationship, backref
from geoalchemy import *
import simplejson as json
import urllib2
import os
import csv
import itertools

#Create and engine and get the metadata
#Base = declarative_base()

engine = create_engine('postgresql://abs:abs@localhost/abs', echo=False) #change here if want to view echo
Session = sessionmaker(bind=engine)
session = Session()


metadata = MetaData(bind=engine)
Base = declarative_base(metadata=metadata)


class sa2(Base):
    __tablename__ = 'sa2'
    __table_args__ = {'autoload': True, 'schema': 'asgs_2011'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))
    #traveltimes = relationship("syd_transit_sa2", backref="sa2")


class syd_transit_sa2(Base):
    __tablename__ = 'sydney_sa2'
    __table_args__ = {'schema': 'transit'}
    id = Column(Integer, primary_key=True)
    from_code = Column(Integer, ForeignKey('asgs_2011.sa2.code'))
    to_code = Column(Integer, ForeignKey('asgs_2011.sa2.code'))
    time = Column(Integer)
    from_sa2_obj = relationship("sa2", foreign_keys=[from_code], backref="syd_transit_sa2_from")
    to_sa2_obj = relationship("sa2", foreign_keys=[to_code], backref="syd_transit_sa2_to")


class sydney_transit(Base):
    __tablename__ = 'tz_nsw_2011'
    __table_args__ = {'autoload': True, 'schema': 'transit'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


class sydney_tz(Base):
    __tablename__ = 'sydney_tz'
    __table_args__ = {'schema': 'transit'}
    id = Column(Integer, primary_key=True)
    from_tz = Column(Integer, ForeignKey('transit.tz_nsw_2011.gid'))
    to_tz = Column(Integer, ForeignKey('transit.tz_nsw_2011.gid'))
    duration = Column(Integer)


all_list = session.query(sydney_tz).filter(sydney_tz.from_tz == "1844")\
    .filter(syd_transit_sa2.time > 50).filter(syd_transit_sa2.time <10000)
for item in all_list:
    print item.to_tz




