__author__ = 'kelvinn'
from sqlalchemy import *
from sqlalchemy.orm import create_session, sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from geoalchemy import postgis
from geoalchemy import *
import simplejson as json
import urllib2
import os
import csv
import itertools

#Create and engine and get the metadata
#Base = declarative_base()

engine = create_engine('postgresql://abs:abs@localhost/abs', echo=False) #change here if want to view echo
Session = sessionmaker(bind=engine)
session = Session()


metadata = MetaData(bind=engine)
Base = declarative_base(metadata=metadata)

class sydney_transit(Base):
    __tablename__ = 'tz_nsw_2011'
    __table_args__ = {'autoload': True, 'schema': 'transit'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


class sydney_tz(Base):
    __tablename__ = 'sydney_tz'
    __table_args__ = {'schema': 'transit'}
    id = Column(Integer, primary_key=True)
    from_tz = Column(Integer, ForeignKey('transit.tz_nsw_2011.gid'))
    to_tz = Column(Integer, ForeignKey('transit.tz_nsw_2011.gid'))
    duration = Column(Integer)

indir = '/var/www/livewhereme/out_tz/'
for root, dirs, filenames in os.walk(indir):
    for f in filenames:
        from_tz_code11 = f.split("_")[1]
        tz_a_obj = session.query(sydney_transit).filter(sydney_transit.tz_code11 == from_tz_code11).first()
        with open(os.path.join(root, f), 'rb') as csvfile:
            gpsreader = csv.reader(csvfile, delimiter=',')
            gpsreader.next()
            for row in gpsreader:
                to_tz_code11 = row[0]
                duration = row[4]
                tz_b_obj = session.query(sydney_transit).filter(sydney_transit.tz_code11 == to_tz_code11).first()
                if tz_a_obj and tz_b_obj and int(float(duration)) > 0:
                    #print "From: %s, To: %s, Duration %s" %(tz_a_obj.gid, tz_b_obj.gid, duration)
                    c = sydney_tz()
                    c.to_tz = tz_b_obj.gid
                    c.from_tz = tz_a_obj.gid
                    c.duration = int(float(duration))
                    session.add(c)
            print "Saving %s" % tz_a_obj.dzn_name11
            session.commit()








