__author__ = 'kelvinn'
from sqlalchemy import *
from sqlalchemy.orm import create_session, sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from geoalchemy import postgis
from geoalchemy import *
import simplejson as json
import urllib2
import os
import csv
import itertools

#Create and engine and get the metadata
#Base = declarative_base()

engine = create_engine('postgresql://abs:abs@localhost/abs', echo=False) #change here if want to view echo
Session = sessionmaker(bind=engine)
session = Session()


metadata = MetaData(bind=engine)
Base = declarative_base(metadata=metadata)


class tz_nsw_2011(Base):
    __tablename__ = 'tz_nsw_2011'
    __table_args__ = {'autoload': True, 'schema': 'govhack_2013'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


class universities(Base):
    __tablename__ = 'universities'
    __table_args__ = {'autoload': True, 'schema': 'govhack_2013'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))

class uni_tz_active(Base):
    __tablename__ = 'uni_tz_active'
    __table_args__ = {'schema': 'govhack_2013'}
    gid = Column(Integer, primary_key=True)
    tz = Column(Integer, ForeignKey('govhack_2013.tz_nsw_2011.gid'))
    uni = Column(Integer, ForeignKey('govhack_2013.universities.gid'))
    duration = Column(Integer)

indir = '/home/kelvinn/Desktop/out_uni_active/'
for root, dirs, filenames in os.walk(indir):
    for f in filenames:
        from_uni_gid = f.split("_")[1]
        obj_from = session.query(universities).filter(universities.gid == from_uni_gid).first()
        with open(os.path.join(root, f), 'rb') as csvfile:
            gpsreader = csv.reader(csvfile, delimiter=',')
            gpsreader.next()
            for row in gpsreader:
                to_tz_code11 = row[0]
                duration = row[4]
                obj_to = session.query(tz_nsw_2011).filter(tz_nsw_2011.tz_code11 == to_tz_code11).first()
                if obj_from and obj_to and int(float(duration)) > 0:
                    print "From: %s, To: %s, Duration %s" %(obj_from.name, obj_to.tz_code11, duration)
                    c = uni_tz_active()
                    c.tz = obj_to.gid
                    c.uni = obj_from.gid
                    c.duration = int(float(duration))
                    session.add(c)
            print "Saving %s" % obj_from.name
            session.commit()








