__author__ = 'kelvinn'
from sqlalchemy import *
from sqlalchemy.orm import create_session, sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from geoalchemy import postgis
from geoalchemy import *
import simplejson as json
import urllib2
import itertools

#Create and engine and get the metadata
#Base = declarative_base()

engine = create_engine('postgresql://abs:abs@localhost/abs', echo=False) #change here if want to view echo
Session = sessionmaker(bind=engine)
session = Session()


metadata = MetaData(bind=engine)
Base = declarative_base(metadata=metadata)

"""
class sa1(Base):
    __tablename__ = 'sa1'
    __table_args__ = {'autoload': True, 'schema': 'asgs_2011'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))
"""


class sa2(Base):
    __tablename__ = 'sa2'
    __table_args__ = {'autoload': True, 'schema': 'asgs_2011'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


class syd_transit(Base):
    __tablename__ = 'sydney'
    __table_args__ = {'schema': 'transit'}
    id = Column(Integer, primary_key=True)
    from_code = Column(Integer, ForeignKey('asgs_2011.sa1.code'))
    to_code = Column(Integer, ForeignKey('asgs_2011.sa1.code'))
    time = Column(Integer)

class syd_transit_sa2(Base):
    __tablename__ = 'sydney_sa2'
    __table_args__ = {'schema': 'transit'}
    id = Column(Integer, primary_key=True)
    from_code = Column(Integer, ForeignKey('asgs_2011.sa2.code'))
    to_code = Column(Integer, ForeignKey('asgs_2011.sa2.code'))
    time = Column(Integer)

class medicare(Base):
    __tablename__ = 'medicare'
    __table_args__ = {'autoload': True, 'schema': 'govhack_2013'}
    geom = GeometryColumn(Point())


class mb(Base):
    __tablename__ = 'mb'
    __table_args__ = {'autoload': True, 'schema': 'asgs_2011'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


box = 'POLYGON((149.343 -34.865, 151.908 -34.865, 151.908 -32.384, 149.343 -32.384, 149.343 -34.865))'
nsw_sa2_list_1 = session.query(sa2).filter(sa2.geom.within(box))
nsw_sa2_list_2 = session.query(sa2).filter(sa2.geom.within(box))

url = "http://192.168.83.80:8080/opentripplanner-api-webapp/ws/plan?_dc=1369733577423&arriveBy=true&numItineraries=1&maxTransfers=1&walkSpeed=20&batch=true&time=8%3A30am&ui_date=5%2F28%2F2013&mode=TRANSIT%2CWALK&optimize=QUICK&maxWalkDistance=840&walkSpeed=1.341&date=2013-05-28"

def get_coords(item):
    json_coords = session.scalar(postgis.pg_functions.geojson(functions.centroid(item.geom)))
    coords = json.loads(json_coords)['coordinates']
    return "%s,%s" % (coords[1], coords[0])

for sa2_a in nsw_sa2_list_1:
    i = 0
    for sa2_b in nsw_sa2_list_2:
        url_to_query = url + "&toPlace=%s&fromPlace=%s" % (get_coords(sa2_a), get_coords(sa2_b))
        #print url_to_query
        f = urllib2.urlopen(url_to_query).read()
        plan = json.loads(f)['plan']
        if plan:
            duration = plan['itineraries'][0]['duration']
            print "From %s to %s taking %s" %(sa2_a.code, sa2_b.code, duration)
            #if duration < 500000:
            #print "To Save: %s, %s, %s" % (sa2_a.code, sa2_b.code, duration)
            c = syd_transit_sa2()
            c.to_code = sa2_a.code
            c.from_code = sa2_b.code
            c.time = duration
            session.add(c)
    session.commit()






