__author__ = 'kelvinn'
from sqlalchemy import *
from sqlalchemy.orm import create_session, sessionmaker
from sqlalchemy.ext.declarative import declarative_base
from geoalchemy import postgis
from sqlalchemy.orm import relationship, backref
from geoalchemy import *
import simplejson as json
import urllib2
import os
import csv
import itertools

#Create and engine and get the metadata
#Base = declarative_base()

engine = create_engine('postgresql://abs:abs@localhost/abs', echo=False) #change here if want to view echo
Session = sessionmaker(bind=engine)
session = Session()

metadata = MetaData(bind=engine)
Base = declarative_base(metadata=metadata)


class sa2(Base):
    __tablename__ = 'sa2'
    __table_args__ = {'autoload': True, 'schema': 'asgs_2011'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


class tz_nsw_2011(Base):
    __tablename__ = 'tz_nsw_2011'
    __table_args__ = {'schema': 'govhack_2013'}
    gid = Column(Integer, primary_key=True)
    sa2 = Column(Integer, ForeignKey('asgs_2011.sa2.code'))
    sa2_main11 = Column(Integer)
    tz_code11 = Column(Integer)
    tz_name11 = Column(String(100))
    sa2_obj = relationship("sa2", backref="tz")
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


class lga(Base):
    __tablename__ = 'lga'
    __table_args__ = {'autoload': True, 'schema': 'asgs_2011'}
    geom = GeometryColumn(MultiPolygon(1,srid=4326))


class crime(Base):
    __tablename__ = 'crime'
    __table_args__ = {'schema': 'govhack_2013'}
    gid = Column(Integer, primary_key=True)
    lga = Column(Integer, ForeignKey('asgs_2011.lga.code'))
    rank_2011 = Column(Integer)
    lga_obj = relationship("lga", backref="crime")


class planet_osm_point(Base):
    __tablename__ = 'planet_osm_point'
    __table_args__ = {'autoload': True, 'schema': 'public'}
    way = GeometryColumn(Point(1,srid=4326))

"""
class bcp_number_of_motor_vehicles_sa2(Base):
    __tablename__ = 'bcp_number_of_motor_vehicles_sa2'
    __table_args__ = {'autoload': True, 'schema': 'census_2011'}
"""
#v = session.query(motor_vehicles).all()

# Query and print SA2 name via Time Zone
#tz_obj = session.query(tz_nsw_2011).filter(tz_nsw_2011.tz_code11 == "276").first()
#print tz_obj.sa2_obj.name

# Print crime per LGA
#crime_obj_list = session.query(crime)
#for obj in crime_obj_list:
#    print obj.rank_2011, obj.lga_obj.name


# Print out a supermarket
osm_obj = session.query(planet_osm_point).filter(planet_osm_point.shop == "supermarket").first()
print osm_obj.name


